import { EventEmitter } from '@angular/core';
import { Http } from '@angular/http';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import { Router } from '@angular/router';
import { AuthConfiguration, OpenIDImplicitFlowConfiguration } from '../modules/auth.configuration';
import { OidcSecurityCheckSession } from './oidc.security.check-session';
import { OidcSecuritySilentRenew } from './oidc.security.silent-renew';
import { OidcSecurityUserService } from './oidc.security.user-service';
import { OidcSecurityCommon } from './oidc.security.common';
import { AuthWellKnownEndpoints } from './auth.well-known-endpoints';
export declare class OidcSecurityService {
    private platformId;
    private http;
    private authConfiguration;
    private router;
    private oidcSecurityCheckSession;
    private oidcSecuritySilentRenew;
    private oidcSecurityUserService;
    private oidcSecurityCommon;
    private authWellKnownEndpoints;
    onUserDataLoaded: EventEmitter<any>;
    onModuleSetup: EventEmitter<any>;
    checkSessionChanged: boolean;
    isAuthorized: boolean;
    private headers;
    private oidcSecurityValidation;
    private errorMessage;
    private jwtKeys;
    private authWellKnownEndpointsLoaded;
    constructor(platformId: Object, http: Http, authConfiguration: AuthConfiguration, router: Router, oidcSecurityCheckSession: OidcSecurityCheckSession, oidcSecuritySilentRenew: OidcSecuritySilentRenew, oidcSecurityUserService: OidcSecurityUserService, oidcSecurityCommon: OidcSecurityCommon, authWellKnownEndpoints: AuthWellKnownEndpoints);
    setupModule(openIDImplicitFlowConfiguration: OpenIDImplicitFlowConfiguration): void;
    getToken(): any;
    getUserData(): any;
    authorize(): void;
    authorizedCallback(): void;
    logoff(): void;
    private successful_validation();
    private refreshSession();
    private setAuthorizationData(access_token, id_token);
    private createAuthorizeUrl(nonce, state);
    private resetAuthorizationData(isRenewProcess);
    handleError(error: any): void;
    private onCheckSessionChanged();
    private onWellKnownEndpointsLoaded();
    private runGetSigningKeys();
    private getSigningKeys();
    private extractData(res);
    private handleErrorGetSigningKeys(error);
    private runTokenValidatation();
}
